"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClearCssModuleDefinitionsPlugin = void 0;
const del_1 = __importDefault(require("del"));
const globby_1 = __importDefault(require("globby"));
const fork_ts_checker_webpack_plugin_1 = __importDefault(require("fork-ts-checker-webpack-plugin"));
class ClearCssModuleDefinitionsPlugin {
    constructor(options) {
        this.options = options;
    }
    apply(compiler) {
        const hooks = fork_ts_checker_webpack_plugin_1.default.getCompilerHooks(compiler);
        hooks.issues.tap('ClearCssModuleDefinitionsPlugin', (issues) => {
            if (!this.options.deleted) {
                let files = globby_1.default.sync(['src/**/*.module.scss.d.ts'], { cwd: this.options.rootFolder });
                files = files.map(f => f.replace('module.scss.d.ts', 'module.scss.ts'));
                del_1.default.sync(files, { cwd: this.options.rootFolder });
                this.options.deleted = true;
            }
            return issues;
        });
    }
}
exports.ClearCssModuleDefinitionsPlugin = ClearCssModuleDefinitionsPlugin;
//# sourceMappingURL=ClearCssModuleDefinitionsPlugin.js.map