"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyServeSettings = void 0;
const helpers_1 = require("../webpack/helpers");
const fullScreenErrors_1 = require("./fullScreenErrors");
const hotRefresh_1 = require("./hotRefresh");
const loggingLevel_1 = require("./loggingLevel");
const open_1 = require("./open");
const openUrl_1 = require("./openUrl");
function applyServeSettings(config) {
    const settings = helpers_1.getJSONFile('fast-serve/config.json');
    helpers_1.setDefaultServeSettings(settings);
    open_1.applyOpenSetting(config, settings.serve);
    openUrl_1.applyOpenUrlSetting(config, settings.serve);
    fullScreenErrors_1.applyFullScreenErrors(config, settings.serve);
    loggingLevel_1.applyLoggingLevel(config, settings.serve);
    hotRefresh_1.applyhotRefresh(config, settings.serve);
}
exports.applyServeSettings = applyServeSettings;
//# sourceMappingURL=index.js.map