"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addSaveConfigTask = void 0;
const fs_1 = require("fs");
const path = __importStar(require("path"));
function addSaveConfigTask(build) {
    const saveConfigTask = build.subTask('save-webpack-config', (gulp, config, done) => {
        const serveAdditionalConfig = (generatedConfiguration) => {
            const saveTo = path.join(config.rootPath, 'temp/_webpack_config.json');
            fs_1.writeFileSync(saveTo, JSON.stringify(generatedConfiguration, null, 2));
            return generatedConfiguration;
        };
        if (!build.configureWebpack.taskConfig.additionalConfiguration) {
            build.configureWebpack.mergeConfig({
                additionalConfiguration: serveAdditionalConfig
            });
        }
        else {
            const oldConfigFunc = build.configureWebpack.taskConfig.additionalConfiguration;
            build.configureWebpack.mergeConfig({
                additionalConfiguration: (generatedConfiguration) => {
                    generatedConfiguration = oldConfigFunc(generatedConfiguration);
                    return serveAdditionalConfig(generatedConfiguration);
                }
            });
        }
        done();
    });
    build.rig.addPostTypescriptTask(saveConfigTask);
}
exports.addSaveConfigTask = addSaveConfigTask;
//# sourceMappingURL=saveConfigTask.js.map