"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resultConfig = void 0;
const path = __importStar(require("path"));
const copy_webpack_plugin_1 = __importDefault(require("copy-webpack-plugin"));
const del_1 = __importDefault(require("del"));
const webpack_merge_1 = require("webpack-merge");
const DynamicLibraryPlugin_1 = require("../plugins/DynamicLibraryPlugin");
const helpers_1 = require("./helpers");
const baseConfig_1 = require("./baseConfig");
const settings_1 = require("../settings");
const rootFolder = path.resolve(process.cwd());
const { transformConfig, webpackConfig } = require(path.join(rootFolder, 'fast-serve/webpack.extend'));
const createConfig = function () {
    helpers_1.checkVersions();
    const settings = helpers_1.getJSONFile('fast-serve/config.json');
    const baseConfig = baseConfig_1.createBaseConfig(settings.cli.isLibraryComponent);
    del_1.default.sync(['dist/*.js', 'dist/*.map'], { cwd: rootFolder });
    const originalWebpackConfig = helpers_1.getJSONFile('temp/_webpack_config.json');
    baseConfig.externals = originalWebpackConfig.externals;
    baseConfig.output = originalWebpackConfig.output;
    baseConfig.entry = helpers_1.getEntryPoints(originalWebpackConfig.entry);
    baseConfig.output.publicPath = `https://${baseConfig.devServer.host}:${baseConfig.devServer.port}/dist/`;
    const manifest = helpers_1.getJSONFile('temp/manifests.json');
    const { localizedResources } = helpers_1.getJSONFile('config/config.json');
    const modulesMap = {};
    const originalEntries = Object.keys(originalWebpackConfig.entry);
    for (const jsModule of manifest) {
        if (jsModule.loaderConfig
            && jsModule.loaderConfig.entryModuleId
            && originalEntries.indexOf(jsModule.loaderConfig.entryModuleId) !== -1) {
            const entryModuleId = jsModule.loaderConfig.entryModuleId;
            modulesMap[entryModuleId + '.js'] = {
                id: jsModule.id,
                version: jsModule.version,
                path: jsModule.loaderConfig.scriptResources[entryModuleId].path
            };
        }
    }
    baseConfig.output.filename = function (pathInfo) {
        const entryPointName = pathInfo.chunk.name + '.js';
        if (!modulesMap[entryPointName]) {
            return '[name].js';
        }
        return modulesMap[entryPointName].path;
    };
    baseConfig.plugins.push(new DynamicLibraryPlugin_1.DynamicLibraryPlugin({
        modulesMap: modulesMap,
        libraryName: originalWebpackConfig.output.library
    }));
    const patterns = helpers_1.addCopyLocalizedResources(localizedResources);
    baseConfig.plugins.push(new copy_webpack_plugin_1.default({
        patterns
    }));
    settings_1.applyServeSettings(baseConfig);
    return baseConfig;
};
const resultConfig = () => webpack_merge_1.merge(transformConfig(createConfig()), webpackConfig);
exports.resultConfig = resultConfig;
//# sourceMappingURL=configureWebPack.js.map